api/administration/urls.py
from django.contrib.auth import views
from django.contrib.auth.decorators import login_required
from django.urls import path
from rest_framework import routers
from django.urls import include, path
from . import views as admin_views
from .services.order_view import OrderView
from .services.aggregator_view import AggregatorView
from .services.store_view import StoreView
from .services.menu_view import MenuView
from .forms import UserLoginForm

# router = routers.DefaultRouter()
# router.register(r'aggregator', AggregatorView, basename='aggregator')
# router.register(r'store', StoreView, basename='store')
# router.register(r'menu', MenuView, basename='menu')
# router.register(r'order', OrderView, basename='order')

urlpatterns = [
    path('index', login_required(admin_views.index_view), name="index"),
    path('login', views.LoginView.as_view(template_name="app/login.html", authentication_form=UserLoginForm),
         name='login'),
    path('logout', login_required(admin_views.logout_view), name='logout'),
    # path('', include(router.urls)),
    path('user', login_required(admin_views.user_list), name="user_list"),
    path('user/add', login_required(admin_views.user_add), name="user_add"),
    path('user/edit/<str:id>', login_required(admin_views.user_edit), name="user_edit"),
    path('store/add', login_required(admin_views.store_add), name="store_add"),
    path('store/edit/<str:id>', login_required(admin_views.store_edit), name="store_edit"),
    path('store/detail/<str:id>', login_required(admin_views.store_detail), name="store_detail"),
    path('aggregator/add', login_required(admin_views.aggregator_add), name="aggregator_add"),
    path('aggregator/edit/<str:id_pk>', login_required(admin_views.aggregator_edit), name="aggregator_edit"),
    path('aggregator', login_required(admin_views.aggregators_list), name="aggregators_list"),
    path('menu', login_required(admin_views.menus_list), name="menus_list"),
    path('menu/detail/<str:id>', login_required(admin_views.menu_detail), name="menu_detail"),
    path('order', login_required(admin_views.orders_list), name="orders_list"),
    path('order/canceled', login_required(admin_views.orders_canceled_list), name="orders_canceled_list"),
    path('order/not_received', login_required(admin_views.orders_not_received_list), name="orders_not_received_list"),
]

api/api/urls.py
from django.contrib import admin
from django.urls import path, include, re_path
from drf_yasg import openapi
from drf_yasg.views import get_schema_view
from rest_framework import permissions


schema_view = get_schema_view(
    openapi.Info(
        title="API",
        default_version='v1',
        description="API for interaction between Pixel and the aggregators"
    ),
    public=True,
    permission_classes=(permissions.AllowAny,),
)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/menu-app/', include(('menu.urls', 'menu'), namespace='menu')),
    path('api/order-app/', include(('order.urls', 'order'), namespace='order')),
    path('api/store-app/', include(('store.urls', 'store'), namespace='store')),
    path('', include(('administration.urls', 'administration'), namespace='administration')),
    re_path(r'^doc(?P<format>\.json|\.yaml)$', schema_view.without_ui(cache_timeout=0), name='schema-json'),
    path('doc/', schema_view.with_ui('swagger', cache_timeout=0), name='schema-swagger-ui'),
    path('redoc/', schema_view.with_ui('redoc', cache_timeout=0), name='schema-redoc'),
    # path('accounts/', include('django.contrib.auth.urls')),
    # path('api/auth/', include('djoser.urls.authtoken')),
]

api/administration/models.py
from __future__ import unicode_literals

from django.db import models

# Create your models here.

api/administration/views.py
import json
from datetime import datetime, timedelta

from django.contrib.auth import get_user_model
from django.contrib.auth import logout
from django.db.models import Q
from django.shortcuts import redirect
from django.shortcuts import render
from menu.models import Menu
from order.models import Order, OrderNotReceived
from order.notifications_templates import *
from rest_framework import status
from store.dicts import dict_status_rappi, dict_status_pixel, dict_status_final, dict_mode
from store.enum import OrderStatusFinalEnum
from store.models import Store, Aggregator, StoreAggregator, Token

from .bad_request import BadRequest
from .error_type import ErrorType
from .forms import CustomUserCreationForm, CustomUserEditionForm
from .request_error import RequestError
from .serializers import StoreSerializer, AggregatorSerializer


def index_view(request):
    """
    Render to list of Stores
    """
    context = {'stores': get_stores_data()}
    return render(request, "store/store_list.html", context)


def get_aggregators_string(aggregators: []):
    aggregators_concat = ''
    for aggregator in aggregators:
        aggregators_concat = aggregators_concat + ', ' + aggregator
    return aggregators_concat[1:]


def get_stores_data():
    stores_data_list = []
    stores = Store.objects.all().order_by('name')
    for store in stores:
        aggregators_names = get_aggregators_string(store.aggregator.values_list('name', flat=True))
        stores_data_list.append({'id': store.id_pk,
                                 'integrationId': store.integrationId,
                                 'name': store.name,
                                 'active': store.active,
                                 'production_mode': store.production_mode,
                                 'develop_mode': store.develop_mode,
                                 'aggregators': aggregators_names})
    return stores_data_list


def get_aggregators_data():
    aggregators = Aggregator.objects.all().order_by('name')
    context = {'aggregators': aggregators}
    return context


def store_add(request):
    """
    Allows add or edit a Store
    """
    if request.method == 'POST':
        if not request.POST.get('ruc'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR, message=INSERT_STORE_WITHOUT_RUC))

        if not request.POST.get('stablishment_number'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=INSERT_STORE_WITHOUT_STABLISHMENT_NUMBER))

        integrationId = request.POST.get('ruc') + '-' + request.POST.get('stablishment_number')
        if integrationId and Store.objects.filter(integrationId=integrationId):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=ALREADY_EXIST_STORE_ID.format(integrationId)))

        store_data = {'integrationId': integrationId,
                      'name': request.POST.get('name'),
                      'active': True if request.POST.get('active') else False,
                      'production_mode': True if request.POST.get('active-production-mode') else False,
                      'develop_mode': True if request.POST.get('active-develop-mode') else False}

        store_serializer = StoreSerializer(data=store_data)

        if store_serializer.is_valid():
            store = store_serializer.save()

            aggregators_selected = request.POST.getlist('aggregators', [])
            store_aggregator_list = []
            for aggregator_id in aggregators_selected:
                aggregator_inserted = Aggregator.objects.get(id_pk=aggregator_id)

                relation_id = request.POST.get(aggregator_inserted.name) if request.POST.get(
                    aggregator_inserted.name) else None
                production_credentials = request.POST.get('production-credentials-' + aggregator_inserted.name)
                develop_credentials = request.POST.get('develop-credentials-' + aggregator_inserted.name)

                # prod_cred_dict = {}
                # dev_cred_dict = {}
                try:
                    prod_cred_dict = json.loads(production_credentials) if production_credentials else None
                except:
                    return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                      exception=RequestError(error_type=ErrorType.ERROR,
                                                             message=ERROR_CREDENTIALS.format('producción')))

                try:
                    dev_cred_dict = json.loads(develop_credentials) if develop_credentials else None
                except:
                    return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                      exception=RequestError(error_type=ErrorType.ERROR,
                                                             message=ERROR_CREDENTIALS.format('desarrollo')))

                store_aggregator = StoreAggregator(store=store, aggregator=aggregator_inserted,
                                                   relation_id=relation_id,
                                                   production_credentials=prod_cred_dict,
                                                   develop_credentials=dev_cred_dict)

                store_aggregator_list.append(store_aggregator)

            StoreAggregator.objects.bulk_create(store_aggregator_list)

        else:
            return BadRequest(http_status_code=status.HTTP_409_CONFLICT,
                              exception=RequestError(error_type=ErrorType.ERROR, message=CANT_INSERT_STORE))

        context = {'stores': get_stores_data()}
        return render(request, 'store/store_list.html', context)

    elif request.method == 'GET':
        context = {'create': True,
                   'aggregators': Aggregator.objects.all().order_by('name')}

        return render(request, 'store/store_form.html', context)


def store_edit(request, id):
    context = {}
    try:
        store = Store.objects.get(id_pk=id)
    except:
        error_mssg = NOT_EXIST_STORE_ID.format(id)
        return BadRequest(http_status_code=status.HTTP_404_NOT_FOUND,
                          exception=RequestError(error_type=ErrorType.ERROR, message=error_mssg))

    if request.method == 'POST':
        if not request.POST.get('ruc'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR, message=EDIT_STORE_WITHOUT_RUC))

        if not request.POST.get('stablishment_number'):
            return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                              exception=RequestError(error_type=ErrorType.ERROR,
                                                     message=EDIT_STORE_WITHOUT_STABLISHMENT_NUMBER))

        new_integration_id = request.POST.get('ruc') + '-' + request.POST.get('stablishment_number')
        if new_integration_id and Store.objects.filter(~Q(id_pk=id), integrationId=new_integration_id):
            error_mssg = ALREADY_EXIST_STORE_ID.format(new_integration_id)
            return BadRequest(http_status_code=status.HTTP_409_CONFLICT,
                              exception=RequestError(error_type=ErrorType.ERROR, message=error_mssg))

        store_data = {'integrationId': new_integration_id,
                      'name': request.POST.get('name'),
                      'active': True if request.POST.get('active') else False,
                      'production_mode': True if request.POST.get('active-production-mode') else False,
                      'develop_mode': True if request.POST.get('active-develop-mode') else False}

        if new_integration_id:
            store, _ = Store.objects.update_or_create(id_pk=id, defaults=store_data)

        if store:
            Token.objects.filter(id=id).delete()

            aggregators_selected = request.POST.getlist('aggregators', [])

            store_aggregator_list = []
            for aggregator_id in aggregators_selected:
                try:
                    aggregator_inserted = Aggregator.objects.get(id_pk=aggregator_id)

                    relation_id = request.POST.get(aggregator_inserted.name) if request.POST.get(
                        aggregator_inserted.name) else None
                    production_credentials = request.POST.get('production-credentials-' + aggregator_inserted.name)
                    develop_credentials = request.POST.get('develop-credentials-' + aggregator_inserted.name)

                    try:
                        prod_cred_dict = json.loads(production_credentials) if production_credentials else None
                    except:
                        return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                          exception=RequestError(error_type=ErrorType.ERROR,
                                                                 message=ERROR_CREDENTIALS.format('producción')))

                    try:
                        dev_cred_dict = json.loads(develop_credentials) if develop_credentials else None
                    except:
                        return BadRequest(http_status_code=status.HTTP_400_BAD_REQUEST,
                                          exception=RequestError(error_type=ErrorType.ERROR,
                                                                 message=ERROR_CREDENTIALS.format('desarrollo')))

                    store_aggregator = StoreAggregator(store=store, aggregator=aggregator_inserted,
                                                       relation_id=relation_id,

api/order/controllers/invoice_controller.py
from ..serializers.invoice_serializer import InvoiceSerializer


class InvoiceController:

    def insert_invoice(self, data):
        invoice_data_serializer = {'company_name': data.get('company_name', None),
                                   'company_address': data.get('company_name', None),
                                   'tax_id': data.get('company_name', None)}
        invoice_serializer = InvoiceSerializer(data=invoice_data_serializer)
        if invoice_serializer.is_valid():
            return invoice_serializer.save()
        return None

api/administration/templates/app/chartjs.html
{% extends "app/base_site.html" %}

{% block title %} Chart JS {% endblock title %}

{% block stylesheets %}
  {{ block.super }}
{% endblock stylesheets %}

{% block content %}
  <div class="right_col" role="main">
    <div class="">
      <div class="page-title">
        <div class="title_left">
          <h3>Chart Js <small>Some examples to get you started</small></h3>
        </div>

        <div class="title_right">
          <div class="col-md-5 col-sm-5 col-xs-12 form-group pull-right top_search">
            <div class="input-group">
              <input type="text" class="form-control" placeholder="Search for...">
              <span class="input-group-btn">
                <button class="btn btn-default" type="button">Go!</button>
              </span>
            </div>
          </div>
        </div>
      </div>

      <div class="clearfix"></div>

      <div class="row">
        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Line graph<small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="lineChart"></canvas>
            </div>
          </div>
        </div>

        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Bar graph <small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="mybarChart"></canvas>
            </div>
          </div>
        </div>
      </div>
      <div class="clearfix"></div>
      <div class="row">
        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Radar <small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="canvasRadar"></canvas>
            </div>
          </div>
        </div>

        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Donut Graph <small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="canvasDoughnut"></canvas>
            </div>
          </div>
        </div>
      </div>
      <div class="clearfix"></div>
      <div class="row">
        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Pie Graph Chart <small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="pieChart"></canvas>
            </div>
          </div>
        </div>

        <div class="col-md-6 col-sm-6 col-xs-12">
          <div class="x_panel">
            <div class="x_title">
              <h2>Pie Area Graph <small>Sessions</small></h2>
              <ul class="nav navbar-right panel_toolbox">
                <li><a class="collapse-link"><i class="fa fa-chevron-up"></i></a>
                </li>
                <li class="dropdown">
                  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-wrench"></i></a>
                  <ul class="dropdown-menu" role="menu">
                    <li><a href="#">Settings 1</a>
                    </li>
                    <li><a href="#">Settings 2</a>
                    </li>
                  </ul>
                </li>
                <li><a class="close-link"><i class="fa fa-close"></i></a>
                </li>
              </ul>
              <div class="clearfix"></div>
            </div>
            <div class="x_content">
              <canvas id="polarArea"></canvas>
            </div>
          </div>
        </div>
      </div>
    </div>
    </div>
{% endblock content %}

{% block javascripts %}
  {{ block.super }}
    <!-- Chart.js -->
    <script src="/static/vendors/Chart.js/dist/Chart.min.js"></script>
{% endblock javascripts %}

api/administration/templates/app/footer.html
<div class="pull-right">
  SIMPLTON - Based on Template by <a href="https://colorlib.com/wp/free-bootstrap-admin-dashboard-templates/">Colorlib</a>
</div>
<div class="clearfix"></div>

api/administration/templates/app/sidebar.html
{% load static %}

<div class="left_col scroll-view">
    <div class="navbar nav_title" style="border: 0;">
        <a href="index.html" class="site_title"><i class="fa fa-spinner"></i> <span>Jobber API</span></a>
    </div>

    <div class="clearfix"></div>

    <!-- menu profile quick info -->
    <div class="profile clearfix">
        <div class="profile_pic">
            <img src="{% static '/images/logo_acklins_peq.png' %}" alt="..." class="img-circle profile_img">
        </div>
        <div class="profile_info">
            <span>Bienvenido,</span>
            <h2>{{ user.get_username }}</h2>
        </div>
    </div>
    <!-- /menu profile quick info -->

    <br/>

    <!-- sidebar menu -->
    <div id="sidebar-menu" class="main_menu_side hidden-print main_menu">
        <div class="menu_section">
            <h3>General</h3>
            <ul class="nav side-menu">
                <li>
                    <a href="{% url 'administration:index' %}">
                        <i class="fa fa-home"></i> Tiendas
                    </a>
                </li>
                <li>
                    <a href="{% url 'administration:menus_list' %}">
                        <i class="fa fa-cutlery"></i> Menús
                    </a>
                </li>
                <li>
                    <a href="{% url 'administration:orders_list' %}">
                        <i class="fa fa-file-text-o"></i> Órdenes
                    </a>
                </li>
                <li>
                    <a href="{% url 'administration:orders_canceled_list' %}">
                        <i class="fa fa-file-text-o"></i> Órdenes canceladas
                    </a>
                </li>
                <li>
                    <a href="{% url 'administration:orders_not_received_list' %}">
                        <i class="fa fa-file-text-o"></i> Órdenes no recibidas
                    </a>
                </li>
                <li>
                    <a href="{% url 'administration:aggregators_list' %}">
                        <i class="fa fa-th-list"></i> Agregadores
                    </a>
                </li>
                {% if user.is_superuser or user.is_staff %}
                    <li>
                        <a href="{% url 'administration:user_list' %}">
                            <i class="fa fa-users"></i> Usuarios
                        </a>
                    </li>
                {% endif %}
            </ul>
        </div>
    </div>
    <!-- /sidebar menu -->

    <!-- /menu footer buttons -->
    <div class="sidebar-footer hidden-small">
        <a data-toggle="tooltip" data-placement="top" title="Settings">
            <span class="glyphicon glyphicon-cog" aria-hidden="true"></span>
        </a>
        <a data-toggle="tooltip" data-placement="top" title="FullScreen">
            <span class="glyphicon glyphicon-fullscreen" aria-hidden="true"></span>
        </a>
        <a data-toggle="tooltip" data-placement="top" title="Lock">
            <span class="glyphicon glyphicon-eye-close" aria-hidden="true"></span>
        </a>
        <a data-toggle="tooltip" data-placement="top" title="Logout" href="login.html">
            <span class="glyphicon glyphicon-off" aria-hidden="true"></span>
        </a>
    </div>
    <!-- /menu footer buttons -->
</div>

api/administration/templates/app/top_navigation.html
{% load static %}

<div class="nav_menu">
    <nav>
        <div class="nav toggle">
            <a id="menu_toggle"><i class="fa fa-bars"></i></a>
        </div>

        <ul class="nav navbar-nav navbar-right">
            <li class="">
                <a href="javascript:;" class="user-profile dropdown-toggle" data-toggle="dropdown"
                   aria-expanded="false">
                    <img src="{% static '/images/logo_acklins_peq.png' %}" alt="">{{ user.get_username }}
                    <span class=" fa fa-angle-down"></span>
                </a>
                <ul class="dropdown-menu dropdown-usermenu pull-right">
{#                    <li><a href="javascript:;"> Profile</a></li>#}
{#                    <li>#}
{#                        <a href="javascript:;">#}
{#                            <span class="badge bg-red pull-right">50%</span>#}
{#                            <span>Settings</span>#}
{#                        </a>#}
{#                    </li>#}
{#                    <li><a href="javascript:;">Help</a></li>#}
                    <li><a href="{% url 'administration:logout' %}"><i class="fa fa-sign-out pull-right"></i> Log
                        Out</a></li>
                </ul>
            </li>

{#            <li role="presentation" class="dropdown">#}
{#                <a href="javascript:;" class="dropdown-toggle info-number" data-toggle="dropdown" aria-expanded="false">#}
{#                    <i class="fa fa-envelope-o"></i>#}
{#                    <span class="badge bg-green">6</span>#}
{#                </a>#}
{#                <ul id="menu1" class="dropdown-menu list-unstyled msg_list" role="menu">#}
{#                    <li>#}
{#                        <a>#}
{#                            <span class="image"><img src="/static/images/img.jpg" alt="Profile Image"/></span>#}
{#                            <span>#}
{#                <span>John Doe</span>#}
{#                <span class="time">3 mins ago</span>#}
{#              </span>#}
{#                            <span class="message">#}
{#                Film festivals used to be do-or-die moments for movie makers. They were where...#}
{#              </span>#}
{#                        </a>#}
{#                    </li>#}
{#                    <li>#}
{#                        <a>#}
{#                            <span class="image"><img src="/static/images/img.jpg" alt="Profile Image"/></span>#}
{#                            <span>#}
{#                <span>John Doe</span>#}
{#                <span class="time">3 mins ago</span>#}
{#              </span>#}
{#                            <span class="message">#}
{#                Film festivals used to be do-or-die moments for movie makers. They were where...#}
{#              </span>#}
{#                        </a>#}
{#                    </li>#}
{#                    <li>#}
{#                        <a>#}
{#                            <span class="image"><img src="/static/images/img.jpg" alt="Profile Image"/></span>#}
{#                            <span>#}
{#                <span>John Doe</span>#}
{#                <span class="time">3 mins ago</span>#}
{#              </span>#}
{#                            <span class="message">#}
{#                Film festivals used to be do-or-die moments for movie makers. They were where...#}
{#              </span>#}
{#                        </a>#}
{#                    </li>#}
{#                    <li>#}
{#                        <a>#}
{#                            <span class="image"><img src="/static/images/img.jpg" alt="Profile Image"/></span>#}
{#                            <span>#}
{#                <span>John Doe</span>#}
{#                <span class="time">3 mins ago</span>#}
{#              </span>#}
{#                            <span class="message">#}
{#                Film festivals used to be do-or-die moments for movie makers. They were where...#}
{#              </span>#}
{#                        </a>#}
{#                    </li>#}
{#                    <li>#}
{#                        <div class="text-center">#}
{#                            <a>#}
{#                                <strong>See All Alerts</strong>#}
{#                                <i class="fa fa-angle-right"></i>#}
{#                            </a>#}
{#                        </div>#}
{#                    </li>#}
{#                </ul>#}
{#            </li>#}
        </ul>
    </nav>
</div>